routes/web.php
<?php

use App\Http\Controllers\DepartmentController;
use App\Http\Controllers\EmployeeByDepartmentController;
use App\Http\Controllers\EmployeeController;
use App\Models\EmployeeByDepartment;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('auth.login');
});

Auth::routes();

Route::get('/home', [App\Http\Controllers\HomeController::class, 'index'])->name('home');

Route::middleware(['auth'])->group(function () {
    Route::resource('department', DepartmentController::class);
    Route::resource('employee', EmployeeController::class);
    Route::resource('employees-by-departments', EmployeeByDepartmentController::class);
    //Route::delete('/employee/disincorporate/{id}', [EmployeeController::class, 'disincorporate'])->name('employee.disincorporate');
    Route::get('employees-by-departments/newcreate/{id}', [EmployeeByDepartmentController::class, 'newCreate'])->name('employees-by-departments.newcreate');
});

app/Models/Employee.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;
use Illuminate\Database\Eloquent\Factories\HasFactory;

class Employee extends Model
{
    use HasFactory;
    use SoftDeletes;
    
    protected $fillable = [
        'name',
        'last_name',
        'cedula',
        'birthday',
        'id_gender',
        'years_old',
        'status',
        'email',
        'id',
    ];

    public function gender(){
        return $this->belongsTo(Gender::class, 'id_gender');
    }
    public function departments(){
        return $this->belongsToMany(Department::class);
    }

}

app/Http/Controllers/EmployeeController.php
<?php

namespace App\Http\Controllers;

use App\Http\Requests\EmployeeRequest;
use App\Models\Gender;
use App\Models\Employee;
use Illuminate\Http\Request;

class EmployeeController extends Controller
{
    // función para llamar la tabla con todos los registros
    public function index(){
        $employees = Employee::where('status','=','A')->with('gender')->paginate(10);
        return view('Employee.index', compact('employees'));
    }

    // función para llamar el formulario
    public function create(){
        $generos = Gender::where('status','=','A')->get();
        return view('Employee.create', compact('generos'));
    }

    // función para guardar un registro nuevo
    public function store(EmployeeRequest $request){
        Employee::create($request->validated());
        return response()->json(['success' => true]);
    }

    // función para llamar el formulario con información del registro a editar
    public function edit($id){
        $employees = Employee::where('id','=',$id)->get()->first();
        $generos = Gender::where('status','=','A')->get();
        return view('Employee.edit', compact('generos', 'employees'));
    }

    // función para modificar un registro
    public function update(EmployeeRequest $request, $id){
        $employees = Employee::where('id','=',$id)->get()->first();
        $employees->update($request->validated());
        return response()->json(['success' => true]);
    }

    // función para eliminar permanentemente un registro
    public function destroy($id){
        $employees = Employee::where('id','=',$id)->get()->first();
        $employees->delete();
        return response()->json(['success' => true]);
    }
}

resources/views/Employee/create.blade.php
@extends('layouts.app')

@section('content')
    <div class="">
        <form action="" id="formEmpleado" method="post">
            @csrf  
            <div>
                <ul id="tasks" class="mt-3 list-disc list-inside text-sm text-red-600">
     
                </ul>
            </div>
            <div class="row mt-5">
                <div class="col-md-6">
                    <div class="form-group mb-3">
                        <label for="">Nombre:</label>
                        <input type="text" name="name" id="name" class="form-control" placeholder="escribe un nombre" aria-describedby="helpId" required>
                    </div>
                </div>
                <div class="col-md-6">
                    <div class="form-group mb-3">
                        <label for="">Apellido:</label>
                        <input type="text" name="last_name" id="last_name" class="form-control" placeholder="escribe un apellido" aria-describedby="helpId" required>
                    </div>
                </div>
            </div> 
            <div class="row">
                <div class="col-md-6">
                    <div class="form-group mb-3">
                        <label for="">Cedula:</label>
                        <input type="text" name="cedula" id="cedula" maxlength="10" class="form-control" placeholder="escribe una cedula" aria-describedby="helpId" required>
                    </div>
                </div>
                <div class="col-md-6">
                    <div class="form-group mb-3">
                        <label for="">Fecha Nacimiento:</label>
                        <input type="date" name="birthday" id="birthday" class="form-control" aria-describedby="helpId" required>
                    </div>
                </div>
            </div>
            <div class="row mb-3">
                <div class="col-md-6">
                    <div class="form-group">
                        <label for="">Género:</label>
                        <select class="form-control selectpicker" name="id_gender" id="id_gender" required>
                            <option>Seleccione un genero</option>
                            @foreach ($generos as $gender)
                                <option value="{{$gender->id}}">{{$gender->name}}</option>
                            @endforeach
                        </select>
                    </div>
                </div>
            </div>
            
            <div class="float-right">
                <button class="btn btn-success" id="btnRegistrarEmpleado">Registrar</button>
                <a class="btn btn-warning" href="" id="btnBack">Atras</a>
            </div>
        </form>
    </div> 
@endsection

@push('javascript')

    <!-- Petición ajax para guardar un registro en la base de datos -->
    <script>
        $('#btnRegistrarEmpleado').on('click', function(e){
            e.preventDefault();
            // obtener valores de los inputs
            let name        = $('#name').val();
            let last_name   = $('#last_name').val();
            let cedula      = $('#cedula').val();
            let birthday    = $('#birthday').val();
            let id_gender   = $('#id_gender').val();
            let _token      = $('input[name=_token]').val();
            let birthday2 = new Date(birthday);
            let date        = new Date();
            let years_old   =  Math.floor((date-birthday2) / (365.25 * 24 * 60 * 60 * 1000));
            //Petición ajax
            $.ajax({
                type: "POST",
                url: "{{route('employee.store')}}",
                data: {
                    name        : name,
                    last_name   : last_name,
                    cedula      : cedula,
                    birthday    : birthday,
                    id_gender   : id_gender,
                    years_old   : years_old,
                    _token      : _token
                },
                success:function(response){
                    setTimeout(() => {
                        toastr.success('Registro exitoso', 'Nuevo registro');
                        window.location.href = '/employee'
                    }, 1000);
                },
                error: function (err) {
                    if(err.status == 422){
                        let template = `
                            <div class="card alert-icon flex-1 items-center border-2 border-red-500 justify-center rounded-full mt-2">

                            `;

                        $.each(err.responseJSON.errors, function (i,error) {
                        template += `
                                <li class="ml-2 text-danger">
                                    ${error[0]}
                                </li>
                                `
                        });
                        template += `</div>`;
                        $('#tasks').html(template);
                    }
                }   
            });
        });
    </script>
    <script>
    $('#btnBack').on('click', function(e){
        $.ajax({
                type: "GET",
                url: "{{route('employee.index')}}",
                success:function(response){
                    window.location.href = '/employee'
                },
        });
    });
    </script>
@endpush

resources/views/Employee/edit.blade.php
@extends('layouts.app')

@section('content')
    <div class="">
        <form action="" id="formEmpleado" method="post">
            @csrf  
            @method('PUT')
            <div>
                <ul id="tasks" class="mt-3 list-disc list-inside text-sm text-red-600">
     
                </ul>
            </div>
            <div class="row mt-5">
                <div class="col-md-6">
                    <div class="form-group mb-3">
                        <label for="">Nombre:</label>
                        <input type="text" name="name" id="name" class="form-control" placeholder="escribe un nombre" aria-describedby="helpId" value="{{$employees->name}}" required>
                    </div>
                </div>
                <div class="col-md-6">
                    <div class="form-group mb-3">
                        <label for="">Apellido:</label>
                        <input type="text" name="last_name" id="last_name" class="form-control" placeholder="escribe un apellido" aria-describedby="helpId" value="{{$employees->last_name}}" required>
                    </div>
                </div>
            </div> 
            <div class="row">
                <div class="col-md-6">
                    <div class="form-group mb-3">
                        <label for="">Cedula:</label>
                        <input type="text" name="cedula" id="cedula" class="form-control" placeholder="escribe una cedula" aria-describedby="helpId" value="{{$employees->cedula}}" required>
                    </div>
                </div>
                <div class="col-md-6">
                    <div class="form-group mb-3">
                        <label for="">Fecha Nacimiento:</label>
                        <input type="date" name="birthday" id="birthday" class="form-control" aria-describedby="helpId" value="{{$employees->birthday}}" required>
                    </div>
                </div>
            </div>
            <div class="row mb-3">
                <div class="col-md-6">
                    <div class="form-group">
                        <label for="">Género:</label>
                        <select class="form-control selectpicker" name="id_gender" id="id_gender" required>
                            <option>Seleccione un genero</option>
                            @foreach ($generos as $gender)
                                <option value="{{$gender->id}}" {{$employees->id_gender == $gender->id ? 'selected' : ''}}>{{$gender->name}}</option>
                            @endforeach
                        </select>
                    </div>
                </div>
                <div class="col-md-6">
                    <input type="hidden" name="id" id="id" value="{{ $employees->id }}">
                </div>
            </div>
            <div class="float-right">
                <button class="btn btn-success" id="btnEditarEmpleado">Editar</button>
                <a class="btn btn-warning" href="{{route('employee.index')}}" id="btnBack">Atras</a>
            </div>
        </form>
    </div> 
@endsection

@push('javascript')

    <script>
        $('#btnEditarEmpleado').on('click', function(e){
            e.preventDefault();
            // obtener valores de los inputs
            let name        = $('#name').val();
            let last_name   = $('#last_name').val();
            let cedula      = $('#cedula').val();
            let birthday    = $('#birthday').val();
            let id_gender   = $('#id_gender').val();
            let id          = $('#id').val();
            let _token      = $('input[name=_token]').val();
            let birthday2 = new Date(birthday);
            let date        = new Date();
            let years_old   =  Math.floor((date-birthday2) / (365.25 * 24 * 60 * 60 * 1000));
            // Petición ajax
            $.ajax({
                type: "PUT",
                url: "{{route('employee.update', $employees->id)}}",
                data: {
                    id          : id,
                    name        : name,
                    last_name   : last_name,
                    cedula      : cedula,
                    birthday    : birthday,
                    id_gender   : id_gender,
                    years_old   : years_old,
                    _token      : _token
                },
                success:function(response){
                    setTimeout(() => {
                        toastr.success('Modificación exitosa', 'Modificar registro');
                        window.location.href = '/employee'
                    }, 1000);
                },
                error: function (err) {
                    if(err.status == 422){
                        let template = `
                            <div class="card alert-icon flex-1 items-center border-2 border-red-500 justify-center rounded-full mt-2">

                            `;

                        $.each(err.responseJSON.errors, function (i,error) {
                        template += `
                                <li class="ml-2 text-danger">
                                    ${error[0]}
                                </li>
                                `
                        });
                        template += `</div>`;
                        $('#tasks').html(template);
                    }
                }   
            });
        });
    </script>

    <script>
    $('#btnBack').on('click', function(e){
        $.ajax({
                type: "GET",
                url: "{{route('employee.index')}}",
                success:function(response){
                    window.location.href = '/employee'
                },
        });
    });
    </script>
@endpush

resources/views/Employee/index.blade.php
@extends('layouts.app')

@section('content')

    <div class="container">
        <div class="row mb-5 mt-5">
            <div class="col-md-6" style="display:flex;">
                <h3 class="text-secondary">Empleados</h3>
                <a href="" class="btn btn-primary" style="margin-left: 30px;" id="btnNuevoEmpleado">Nuevo empleado</a>
            </div>
            <div class="col-md-6">
            </div>
        </div>
    </div>
    <div class="table-responsive col-md-12">
        <table class="table table-bordered table-hover" id="table-generic">
            <thead class="thead-light">
                <tr>
                    <th class="text-center">Id</th>
                    <th class="text-center">Nombre</th>
                    <th class="text-center">Cedula</th>
                    <th class="text-center">Fecha Nac.</th>
                    <th class="text-center">Edad</th>
                    <th class="text-center">Género</th>
                    <th class="text-center">Editar</th>
                    <th class="text-center">Eliminar</th>

                </tr>
            </thead>
            <tbody>
                @if (count($employees) > 0)
                    @foreach ($employees as $employee)
                        <tr id="rowId-{{$employee->id}}">
                            <td class="text-center">
                                {{$employee->id}}
                            </td>
                            <td class="text-center">
                                {{$employee->name . ' ' . $employee->last_name}}
                            </td>
                            <td class="text-center">
                                {{$employee->cedula}}
                            </td>
                            <td class="text-center">
                                {{$employee->birthday}}
                            </td>
                            <td class="text-center">
                                {{$employee->years_old}}
                            </td>
                            <td class="text-center">
                                {{$employee->gender->description}}
                            </td>
                            <td class="text-center">
                                <a href="{{route('employee.edit', $employee->id)}}" id="editBtn" class="btn btn-outline-warning" title="Modificar"><svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-pencil" viewBox="0 0 16 16">
                                    <path d="M12.146.146a.5.5 0 0 1 .708 0l3 3a.5.5 0 0 1 0 .708l-10 10a.5.5 0 0 1-.168.11l-5 2a.5.5 0 0 1-.65-.65l2-5a.5.5 0 0 1 .11-.168l10-10zM11.207 2.5 13.5 4.793 14.793 3.5 12.5 1.207 11.207 2.5zm1.586 3L10.5 3.207 4 9.707V10h.5a.5.5 0 0 1 .5.5v.5h.5a.5.5 0 0 1 .5.5v.5h.293l6.5-6.5zm-9.761 5.175-.106.106-1.528 3.821 3.821-1.528.106-.106A.5.5 0 0 1 5 12.5V12h-.5a.5.5 0 0 1-.5-.5V11h-.5a.5.5 0 0 1-.468-.325z"/>
                                    </svg>
                                </a>
                            </td>
                            <td class="text-center">
                                <form action="" style="display: inline" method="POST">
                                    @csrf
                                    @method('DELETE')
                                    <button id="btnDelete" valor="{{$employee->id}}" class="btn btn-outline-danger" title="Eliminar">
                                        <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-trash" viewBox="0 0 16 16">
                                        <path d="M5.5 5.5A.5.5 0 0 1 6 6v6a.5.5 0 0 1-1 0V6a.5.5 0 0 1 .5-.5zm2.5 0a.5.5 0 0 1 .5.5v6a.5.5 0 0 1-1 0V6a.5.5 0 0 1 .5-.5zm3 .5a.5.5 0 0 0-1 0v6a.5.5 0 0 0 1 0V6z"/>
                                        <path fill-rule="evenodd" d="M14.5 3a1 1 0 0 1-1 1H13v9a2 2 0 0 1-2 2H5a2 2 0 0 1-2-2V4h-.5a1 1 0 0 1-1-1V2a1 1 0 0 1 1-1H6a1 1 0 0 1 1-1h2a1 1 0 0 1 1 1h3.5a1 1 0 0 1 1 1v1zM4.118 4 4 4.059V13a1 1 0 0 0 1 1h6a1 1 0 0 0 1-1V4.059L11.882 4H4.118zM2.5 3V2h11v1h-11z"/>
                                        </svg>
                                    </button>
                                </form>
                            </td>
                        </tr>
                    @endforeach
                @else
                        <tr>
                            <td colspan="5" class="text-center">No hay registros en el sistema</td>
                        </tr>
                @endif
                
            </tbody>
        </table>
        <div class="d-flex justify-content-end">
            {{ $employees->links() }}
        </div>
    </div>

@endsection

@push('javascript')
    <!-- Petición ajax para llamar a la vista create -->
    <script>
        $('#btnNuevoEmpleado').on('click', function(e){
            // Petición ajax
            $.ajax({
                type: "GET",
                url: "{{route('employee.create')}}",
                success: function() { 
                    window.location.href = '/employee/create'
                },
                error: function(xhr, ajaxOptions, thrownerror) { }
            })
        });
    </script>
    <script>
        // Ajax para eliminar un registro
        $(document).on('click', '#btnDelete', function(e){
            if(confirm('Está seguro que quiere despedir al empleado?')){
                e.preventDefault();
                let id = $(this).attr('valor');
                let _token = $('input[name=_token]').val();
                $.ajax({
                    type: "DELETE",
                    url: `employee/${id}`,
                    data: {
                        id: id,
                        _token: _token
                    },
                    success:function(response){
                        toastr.success('Registro Eliminado', 'Eliminar', 3000);
                        $('#rowId-'+id).remove();
                    },
                    error: function (err) {
                        if(err.status == 422){
                            $.each(err.responseJSON.errors, function (i,error) {
                                toastr.success('error en eliminacion', +error[0], 3000);
                            })
                        }
                    }
                });
            }else{
                e.preventDefault();
            }
        });
    </script>
@endpush